<br/>
<p align="center">
  <a href="https://github.com/subhomoy-roy-choudhury/milap">
    <img src="https://socialify.git.ci/subhomoy-roy-choudhury/milap/image?description=1&descriptionEditable=A%20Python%20Package%20for%20Google%20Meet%20Operations&font=Source%20Code%20Pro&forks=1&issues=1&language=1&name=1&owner=1&pattern=Circuit%20Board&pulls=1&stargazers=1&theme=Dark" alt="Hack_IP" width="640" height="320" />
  </a>

  <!-- <h3 align="center">Hack IP</h3> -->

  <p align="center">
    A Python Package for Google Meet Operations
    <br/>
    <br/>
    <a href="https://github.com/subhomoy-roy-choudhury/milap"><strong>Explore the docs »</strong></a>
    <br/>
    <br/>
    <a href="https://github.com/subhomoy-roy-choudhury/milap">View Demo</a>
    .
    <a href="https://github.com/subhomoy-roy-choudhury/milap/issues">Report Bug</a>
    .
    <a href="https://github.com/subhomoy-roy-choudhury/milap/issues">Request Feature</a>
  </p>
</p>

<p align="center">
    <img alt="Test Cases" src="https://github.com/subhomoy-roy-choudhury/milap/actions/workflows/main.yml/badge.svg" />
    <img alt="Downloads" src="https://img.shields.io/github/downloads/subhomoy-roy-choudhury/milap/total" />
    <img alt="GitHub Contributors" src="https://img.shields.io/github/contributors/subhomoy-roy-choudhury/milap?color=dark-green" />
    <img alt="Github Issues" src="https://img.shields.io/github/issues/subhomoy-roy-choudhury/milap" />
    <img alt="GitHub Last Commit" src="https://img.shields.io/github/last-commit/subhomoy-roy-choudhury/milap" />
    <img alt="Repo Size" src="https://img.shields.io/github/repo-size/subhomoy-roy-choudhury/milap" />
    <img alt="GitHub Pull Requests" src="https://img.shields.io/github/issues-pr/subhomoy-roy-choudhury/milap" />
    <img alt="Github License" src="https://img.shields.io/github/license/subhomoy-roy-choudhury/milap" />
    <img alt="Test Cases" src="https://github.com/subhomoy-roy-choudhury/milap/actions/workflows/publish.yml/badge.svg" />


</p>

## Table Of Contents

* [About the Project](#about-the-project)
* [Features](#features)
* [Technical Highlights](#technical-highlights)
* [Usage Scenarios](#usage-scenarios)
* [Getting Started](#getting-started)
  * [Prerequisites](#prerequisites)
  * [Installation](#installation)
* [Usage](#usage)
* [Roadmap](#roadmap)
* [Contributing](#contributing)
* [License](#license)
* [Contact](#contact)
* [Acknowledgements](#acknowledgements)

## About The Project

**Milap** is a Python package designed to simplify the interaction with Google Meet through the Google API Client services. This tool is crafted to assist developers, project managers, and organizations in automating and managing their Google Meet sessions. By encapsulating the complexities of the Google Meet API, this package offers an intuitive and straightforward way to create, update, delete, and fetch Google meeting details programmatically.

## Features

**Milap** comes with a multitude of features:

- **Create Google Meetings**: Automate the process of scheduling new Google meetings. Customize settings such as date, time, participants, and more.
- **Update Existing Meetings**: Modify details of scheduled meetings, such as changing the time, adding participants, or updating the agenda.
- **Delete Meetings**: Provides functionality to cancel meetings, which can be integrated into various applications to handle schedule changes dynamically.
- **Fetch Meeting Information**: Retrieve details about meetings, including participant lists, meeting times, and links, which can be used for reminders, attendance tracking, and more.

## Technical Highlights

- **OAuth 2.0 Integration**: Securely authenticate with Google's services using OAuth 2.0, ensuring compliance with Google's authorization protocols.
- **Pythonic Interface**: The package offers a Pythonic interface, making it easy to integrate into existing Python applications or workflows.
- **Error Handling**: Robust error handling mechanisms to manage API request failures and provide clear feedback.

## Usage Scenarios

- **Automated Meeting Scheduling**: Ideal for applications that require automated scheduling of meetings based on dynamic criteria or events.
- **Calendar Management Systems**: Integrates seamlessly into custom calendar management systems for handling Google Meet sessions.
- **Enterprise Solutions**: Useful for enterprises needing to manage a large number of online meetings across teams or departments.

## Getting Started

To install Milap, follow these steps:

### Prerequisites

1. [Python >=3.9](https://www.python.org/)

### Installation

With pip:

```sh
pip install milap
```

With Poetry:

```sh
peotry add milap
```

## Usage

Read the Documentation [here](https://github.com/subhomoy-roy-choudhury/milap/blob/master/example/sample.py)


## Roadmap

See the [open issues](https://github.com/subhomoy-roy-choudhury/milap/issues) for a list of proposed features (and known issues).

## Contributing

Contributions are what make the open source community such an amazing place to be learn, inspire, and create. Any contributions you make are **greatly appreciated**.
* If you have suggestions for adding or removing projects, feel free to [open an issue](https://github.com/subhomoy-roy-choudhury/milap/issues/new) to discuss it, or directly create a pull request after you edit the *README.md* file with necessary changes.
* Please make sure you check your spelling and grammar.
* Create individual PR for each suggestion.

### Creating A Pull Request

1. Fork the Project
2. Create your Feature Branch (`git checkout -b feature/<feature>`)
3. Commit your Changes (`git commit -m 'Add some <feature>'`)
4. Push to the Branch (`git push origin feature/<feature>`)
5. Open a Pull Request

## License

Distributed under the MIT License. See [LICENSE](https://github.com/subhomoy-roy-choudhury/milap/blob/master/LICENSE) for more information.

## Contact
**Subhomoy Roy Choudhury** - *SDE at Fynd* - [Github](https://src-portfolio.oderna.in/link/GITHUB) - [Linkedin](https://src-portfolio.oderna.in/link/LINKEDIN) - [Twitter](https://src-portfolio.oderna.in/link/TWITTER)

Project Link: [https://github.com/subhomoy-roy-choudhury/milap](https://github.com/subhomoy-roy-choudhury/milap)

## Acknowledgements

* [Poetry](https://www.poetryfoundation.org/)
* [Beautify Github Readme](https://github.com/rzashakeri/beautify-github-profile)
* [Google APIs](https://developers.google.com/apis-explorer)
